@ECHO OFF
setlocal enableDelayedExpansion

ECHO -----------------------------------------------------------------
ECHO                         EXALUX - WELCOME
ECHO -----------------------------------------------------------------
ECHO.
ECHO  This software will update the fimrware of your CONTROL ONE.
ECHO -----------------------------------------------------------------
ECHO.
ECHO.
ECHO STEP 1
ECHO   Connect your CONTROL ONE to your computer via micro-USB.
ECHO   Turn on the device.
ECHO. 
ECHO.
ECHO.
ECHO STEP 2
ECHO   Wait for Windows to automatilly install the required drivers (can take while)
ECHO   or install them manually from the DRIVERS folder provided.
ECHO.
ECHO.
ECHO.
ECHO STEP 3
ECHO   Once drivers are installed, press any key to continue ...
pause >nul



::-----------------------------------------------------------------------------
:: Get the path of thecurrent folder, and create variables that contain the other usefull path
SET mypath=%~dp0
SET utilityPath=%mypath%utility
SET firmwarePath=%mypath%firmware


::-----------------------------------------------------------------------------
:: Count the number of COM port that look like CONTROL ONE.
:: (Use a temporary file to store the result of the commands. Easier than variables)
wmic path win32_pnpentity get caption | FIND "Silicon Labs CP210x USB to UART Bridge" /c > tmpFile
SET /p nbComFound= < tmpFile
DEL tmpFile


::-----------------------------------------------------------------------------
:: If there is only 1 COM Port that corresponds to the CONTROL ONE,
:: Extract the COM Port number, and only ask for confirmation.
:: NOTE : In the IF/ELSE, make sure to use ! and not %, because of the Expension Delay
SET askUserToSelectComPort=0
IF "%nbComFound%" equ "1" (
	
	cls
	ECHO -----------------------------------------------------------------
	ECHO                              EXALUX
	ECHO -----------------------------------------------------------------
	ECHO.
	ECHO.
	
	:: Only 1 COM Port found. The following line extracts the number, in the format "COMxx"
	for /f "tokens=2delims=()" %%A in ('wmic path win32_pnpentity get caption /format:table^| FIND "Silicon Labs CP210x USB to UART Bridge"') do set "COM=%%A"

	:: Remove the "COM", just to keep the number
	SET myCom=!COM:~3!
	
	:: Ask for confirmation to the user
	ECHO The software detected a CONTROL ONE on COM!myCom!.
	ECHO.
	ECHO.
	ECHO To use COM!myCom!, press any key.
	SET /p userChoice="To select another COM Port, press enter. "
	
	IF /I "!userChoice!" == "n" ( 
		SET askUserToSelectComPort=1
	)	
)

IF "%nbComFound%" NEQ "1" (
	:: There are multiple COM ports -> Ask the user
	SET askUserToSelectComPort=1
)



::-----------------------------------------------------------------------------
:: If several COM Port correspond to the CONTROL ONE, or if the user
:: chose to select the COM Port himself, show the list of available COM Ports
IF "%askUserToSelectComPort%" == "1" (

	cls
	ECHO -----------------------------------------------------------------
	ECHO                              EXALUX
	ECHO -----------------------------------------------------------------
	ECHO.
	ECHO.
	ECHO Please, select the COM Port corresponding to your CONTROL ONE.
	ECHO The CONTROL ONE is detected as "Silicon Labs CP210x".
	ECHO.
	ECHO.
	ECHO The software detected the following COM Ports :
	ECHO.
	ECHO *********************************************************
	ECHO.
	wmic path win32_pnpentity get caption /format:table | FIND "COM"
	ECHO *********************************************************
	ECHO.
	ECHO.	
	ECHO|SET /p="Enter the COM Port number to use : "
	SET /p myCom="COM"
)



::-----------------------------------------------------------------------------
:: Kill any previous LoadProgram.exe that might be still running
taskkill /IM LoadProgram.exe /F


::-----------------------------------------------------------------------------
:: Display Transferring message
cls
ECHO -----------------------------------------------------------------
ECHO                              EXALUX
ECHO -----------------------------------------------------------------
ECHO.
ECHO Transferring ...
ECHO.
ECHO This should only take a few seconds ...


::-----------------------------------------------------------------------------
:: Jump to the firmware folder, to find the firmware file (can be either for CONTROL ONE or SKY)
CD "%firmwarePath%"
for /f %%d in ('dir *.4XE /B') do set firmwareFile=%%d


::-----------------------------------------------------------------------------
:: Jump into utility folder, and launch LoadProgram (and wait for completion)
CD "%utilityPath%"
start /w LoadProgram "%firmwarePath%\%firmwareFile%" %myCom%


::-----------------------------------------------------------------------------
:: Display exit message
cls
ECHO -----------------------------------------------------------------
ECHO                              EXALUX
ECHO -----------------------------------------------------------------
ECHO.
ECHO Firmware transfer is now complete.
ECHO.
ECHO.
ECHO Restart your CONTROL ONE and enjoy the new firmware.
ECHO.
ECHO.
ECHO The firmware version can be found on the SUPPORT page, from the HOME screen.
ECHO.
ECHO.
pause